#include <ESP8266WiFi.h>

// Pas deze constanten aan
const char* ssid = "SSID";
const char* password = "WACHTWOORD";
const String telefoon = "+316XXXXXXXX";
const String apikey = "XXXXXX";

// Deze waarden kun je laten staan
const String bericht = "Kamerplant+heeft+dorst!";
const char* host = "api.callmebot.com";
const int ondergrens = 100; // Onder deze meetwaarde is het te droog.
const int veilige_waarde = 300; // Boven deze meetwaarde is het nat genoeg.
int pulsdelay = 1000; // Minimale tijd in milliseconden tussen twee metingen.
const int httpPort = 80;
const int httpsPort = 443;
const String url = "/whatsapp.php?phone=" + telefoon + "&apikey=" + apikey + "&text=" + bericht;
bool alarmverzonden = false;
const int groen = 14; // Pin D5
const int rood = 12; // Pin D6
const int puls = 5; // D1
const int sensor = 0; // A0

void setup() {
  pinMode(puls, OUTPUT);
  digitalWrite(puls, LOW);
  pinMode(groen, OUTPUT);
  pinMode(rood, OUTPUT);
  digitalWrite(groen, LOW);
  digitalWrite(rood, LOW);
  Serial.begin(115200);
}

void alarm() {
  int i = 0;
  Serial.begin(115200);
  Serial.println();
  Serial.print("connecting to ");
  Serial.println(ssid);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    i++;
    if (i >= 240) {
      return;
    }
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  //  WiFiClient client; // Verwijder slashes voor deze regel bij http
  BearSSL::WiFiClientSecure client; // Plaats slashes voor deze regel bij http
  client.setInsecure(); // Plaats slashes voor deze regel bij http
  Serial.print("connecting to ");
  Serial.println(host);
  // if (!client.connect(host, httpPort)) { // Verwijder slashes voor deze regel bij http
  if (!client.connect(host, httpsPort)) { // Plaats slashes voor deze regel bij http
    Serial.println("connection failed");
    return;
  }

  Serial.print("requesting URL: ");
  Serial.println(url);

  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" +
               "User-Agent: BuildFailureDetectorESP8266\r\n" +
               "Connection: close\r\n\r\n");

  Serial.println("request sent");
  while (client.connected()) {
    String line = client.readStringUntil('\n');
    if (line == "\r") {
      Serial.println("headers received");
      break;
    }
  }
  String line = client.readString();
  Serial.println("reply was:");
  Serial.println("==========");
  Serial.println(line);
  Serial.println("==========");
  Serial.println("closing connection");
  client.stop();
  alarmverzonden = true;
}

void loop() {
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
  
  digitalWrite(puls, HIGH);
  int meting = analogRead(sensor);
  digitalWrite(puls, LOW);
  Serial.println(meting);

  if(meting <= ondergrens) { // Te droog!
    Serial.println("Droogtealarm!");
    digitalWrite(groen, LOW);
    digitalWrite(rood, HIGH);
    if(alarmverzonden == false){
      alarm();
    }
    pulsdelay = 1000;
  }
  else if (meting >= veilige_waarde) { // Nat genoeg.
    Serial.println("Voldoende water");
    digitalWrite(groen, HIGH);
    digitalWrite(rood, LOW);
    alarmverzonden = false;
    pulsdelay = 300000;
  }
  delay(pulsdelay);
}
